using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using System.IO;

namespace Seminar
{
    public partial class Form1 : Form
    {
        List<Control> panels;
        panelAlgorithm panel1;// = new panelAlgorithm();
        controlGenotype controlGenotypes;// = new controlGenotype();
        ControlRegistry controlRegistry;
        ControlSteadyState controlSteadyState;
        ControlRoulleteWheel controlRoulleteWheel;
        bool fileOpened;
        public Form1()
        {
            
            InitializeComponent();
            ImageList ls = new ImageList();
            Init();
            
            
        }


        [System.Runtime.InteropServices.DllImport("user32.dll")]
        public extern static int SendMessage(IntPtr hwnd, uint msg, uint wParam,
        uint lParam);


        [System.Runtime.InteropServices.DllImport("user32.dll")] 
        static extern Int32 LockWindowUpdate(Int32 hwndLock);

        public void Init()
        {
            fileOpened = false;
            panels = new List<Control>();
            panel1 = new panelAlgorithm();
            controlGenotypes = new controlGenotype();
            controlRegistry = new ControlRegistry();
            //    controlSteadyState= new ControlSteadyState();
            //      controlRoulleteWheel = new ControlRoulleteWheel();
            this.Controls.Add(controlGenotypes);
            this.Controls.Add(panel1);
            this.Controls.Add(controlRegistry);
            // this.Controls.Add(controlRoulleteWheel);
            // this.Controls.Add(controlSteadyState);
            controlGenotypes.GenotypesChanged += new GenotypesChangedHandler(controlGenotype_GenotypesChanged);
            panel1.AlgorithmChanged += new AlgorithmChangedHandler(panel1_AlgorithmChanged);
            panel1.Location = new Point(200, 20);
            controlGenotypes.Location = new Point(200, 20);
            controlRegistry.Location = new Point(200, 20);
            // controlRoulleteWheel.Location = new Point(200, 20);
            //controlSteadyState.Location = new Point(200, 20);
            //panel1.Show();
            //panel1.Refresh();
             panel1.Visible = false;
             controlGenotypes.Visible = false;
             controlRegistry.Visible = false;
            panels.Add(panel1);
            //panels.Add(panelAlgorithm);
            // panels.Add(panelGenotype);
            panels.Add(controlGenotypes);
            panels.Add(controlRegistry);
            // panels.Add(controlSteadyState);
            //panels.Add(controlRoulleteWheel);
            //  panels.Add(panelRouletteWheel);
            //panels.Add(panelSteadyState);


            //  comboBoxSelectAlg.Items.Add("SteadyStateTournament");
            //  comboBoxSelectAlg.Items.Add("RouletteWheel");



            TreeNode[] children = new TreeNode[] { new TreeNode("Algorithm"), new TreeNode("Genotype"), new TreeNode("Registry") };
            //  TreeNode Algorithm = new TreeNode("Algorithm");
            children[0].Tag = panel1;//Algorithm;

            //  TreeNode Genotype = new TreeNode("Genotype");
            children[1].Tag = controlGenotypes;

            //TreeNode Registry = new TreeNode("Registry");
            children[2].Tag = controlRegistry;
            TreeNode ECF = new TreeNode("ECF", children);
            //TreeNodeCollection 
            treeViewECF.Nodes.Clear();
            treeViewECF.Nodes.Add(ECF);
            /*  treeViewECF.Nodes[0].Nodes.Add(Genotype);
              treeViewECF.Nodes[0].Nodes.Add(Genotype);
              treeViewECF.Nodes[0].Nodes.Add(Registry);*/


        }
        //slati i indeks za koji se nesto obrisalo, dodalo,
        //onda samo na tome indeksu u listi cvorova obrisati
        //a ako se dodalo onda samo dodati
        void controlGenotype_GenotypesChanged(object source,int changedItem)
        {
            //throw new Exception("The method or operation is not implemented.");
            TreeNode[] children=new TreeNode[controlGenotypes.Genotypes.Count];
            int i=0;
            //List<TreeNode> toRemove=new List<TreeNode>();

            //neki genotip je dodan
            if(controlGenotypes.Genotypes.Count>treeViewECF.Nodes[0].Nodes[1].Nodes.Count)
            {
                 TreeNode tempNode=new TreeNode(controlGenotypes.Genotypes[controlGenotypes.Genotypes.Count-1]);
                switch(controlGenotypes.Genotypes[controlGenotypes.Genotypes.Count-1])
                {
                    case "Binary":
                        tempNode.Tag=new ControlBinary();
                        break;
                    case "BitString":
                        tempNode.Tag=new ControlBitString();
                        break;
                    case "Tree":
                        tempNode.Tag=new ControlTree();
                        break;
                }
                this.Controls.Add((Control)tempNode.Tag);
                (tempNode.Tag as Control).Location = new Point(200, 20);
                (tempNode.Tag as Control).Visible = false;
                panels.Add((Control)tempNode.Tag);
                treeViewECF.Nodes[0].Nodes[1].Nodes.Add(tempNode);
            }//neki genotip je izbrisan
            else
            {
                panels.Remove(treeViewECF.Nodes[0].Nodes[1].Nodes[changedItem].Tag as Control);
                treeViewECF.Nodes[0].Nodes[1].Nodes.RemoveAt(changedItem);
            }

                
            /*



            foreach(TreeNode node in treeViewECF.Nodes[0].Nodes[1].Nodes)
            {
                if(!controlGenotypes.Genotypes.Contains(node.Name))
                {
                  //  treeViewECF.Nodes[0].Nodes[1].Nodes.Remove(node);
                    toRemove.Add(node);
                }
            }

            foreach (string s in controlGenotypes.Genotypes)
            {
                bool found=false;
                foreach(TreeNode node in treeViewECF.Nodes[0].Nodes[1].Nodes)
                {
                    if(node.Name==s)
                    {
                        found=true;
                    }
                }
                if(!found)
                {
                   
                    treeViewECF.Nodes[0].Nodes[1].Nodes.Add(
                    
                //children[i++] = new TreeNode(s);
            }
            
            treeViewECF.Nodes[0].Nodes[1].Nodes.cla
            treeViewECF.Nodes[0].Nodes[1].Nodes.AddRange(children);

            */
            
        }

        void  panel1_AlgorithmChanged(object source)
        {
 	       // throw new Exception("The method or operation is not implemented.");
            string name = ((ComboBox)source).SelectedItem as string;
            //if(name=="Steady
            TreeNode tempNode = new TreeNode(name);
          //  this.Controls.Add(controlRoulleteWheel);
            // this.Controls.Add(controlSteadyState);
            // controlRoulleteWheel.Location = new Point(200, 20);
            //controlSteadyState.Location = new Point(200, 20);
           // controlRoulleteWheel.Location = new Point(200, 20);
            //controlSteadyState.Location = new Point(200, 20);
            if (tempNode.Text == "SteadyStateTournament")
                tempNode.Tag =new ControlSteadyState();
            else
             tempNode.Tag = new ControlRoulleteWheel();

            this.Controls.Add((Control)tempNode.Tag);
            (tempNode.Tag as Control).Location = new Point(200, 20);
            (tempNode.Tag as Control).Visible = false;
            panels.Add((Control)tempNode.Tag);
            treeViewECF.Nodes[0].Nodes[0].Nodes.Clear();
            treeViewECF.Nodes[0].Nodes[0].Nodes.Add(tempNode);
        }
        
        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void treeViewECF_AfterSelect(object sender, TreeViewEventArgs e)
        {
            foreach (Control panel in panels)
            {
                panel.Visible = false;
            }
            Control selectedPanel = treeViewECF.SelectedNode.Tag as Control;
            if (selectedPanel != null) selectedPanel.Visible = true;
            this.Refresh();
            
        
        }
        public bool traverseTreeAndWriteXML(TreeNode node, XmlDocument xmlDoc, XmlElement parent)
        {
            XmlElement tempXMLNode = xmlDoc.CreateElement(node.Text);
            if (parent == null) xmlDoc.AppendChild(tempXMLNode);
            else
                parent.AppendChild(tempXMLNode);
            if (node.Tag != null && (node.Tag is xmlInterface))
            {
                xmlInterface ixml = (xmlInterface)node.Tag;
                if (ixml.ToXml(xmlDoc, tempXMLNode) == false)
                {
                    MessageBox.Show("Error in input data in node:" + node.Text);
                    return false;
                }

            }
            if (node.Nodes.Count == 0) return true;
            foreach (TreeNode node1 in node.Nodes)
            {

                if(traverseTreeAndWriteXML(node1,xmlDoc,tempXMLNode)==false)return false;
            }
            return true;
        }


        public XmlDocument MakeXmlDocument()
        {
         //   FileStream fs = new FileStream(outputFileName, FileMode.Create);
            XmlDocument xmlDoc = new XmlDocument();
            xmlDoc.PreserveWhitespace = false;
            //xmlDoc.Load(fs);
           /* XmlElement root = xmlDoc.CreateElement("ECF");
            //XmlElement root2=root.
            XmlElement child = xmlDoc.CreateElement("Algorithm");
           // child.InnerText = "aaaaa";
            //root.AppendChild(child);
            //xmlDoc.AppendChild(root);
            
           // (treeViewECF.Nodes[0].Nodes[1].Nodes[0].Tag as ControlTree).toXml(xmlDoc,child);
            
            xmlDoc.AppendChild(root);
            root.AppendChild(child);*/
            if (treeViewECF.Nodes[0].Nodes[1].Nodes.Count == 0)
            {
                MessageBox.Show("Minimum configuration file must have\n at least one genotype");
              //  fs.Close();
                return null;
            }
            if (!traverseTreeAndWriteXML(treeViewECF.Nodes[0], xmlDoc, null))
            {
               // xmlDoc.RemoveAll();
               // fs.Close();
                return null;
            }
            //xmlDoc.Save(fs);
            return xmlDoc;
            //fs.Close();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //MakeXmlDocument();
        }
        private void traverseXMLDoc(XmlElement root,TreeNode node)
        {
            if (root.ChildNodes.Count == 0) return;
            foreach (XmlNode elemNode in root.ChildNodes)
            {
                XmlElement elem = elemNode as XmlElement;
                if (elem == null) continue;
                bool found = false;
                
                foreach (TreeNode child in node.Nodes)
                {
                    if (child.Text == elem.Name)
                    {
                        found = true;
                        traverseXMLDoc(elem, child);
                        break;
                    }
                }
                if (!found || elem.Name=="Registry")
                {
                    TreeNode tempNode = new TreeNode(elem.Name);
                    switch (elem.Name)
                    {
                        case "Binary":
                            tempNode.Tag = new ControlBinary();
                            (treeViewECF.Nodes[0].Nodes[1].Tag as controlGenotype).AddGenotype("Binary");
                            break;
                        case "BitString":
                            tempNode.Tag = new ControlBitString();
                            (treeViewECF.Nodes[0].Nodes[1].Tag as controlGenotype).AddGenotype("BitString");
                            break;
                        case "Tree":
                            tempNode.Tag = new ControlTree();
                            (treeViewECF.Nodes[0].Nodes[1].Tag as controlGenotype).AddGenotype("Tree");
                            break;
                        case "Registry":
                            //tempNode.Tag = new ControlRegistry();
                            tempNode = node.Nodes[node.Nodes.Count - 1];
                            node.Nodes.Remove(tempNode);
                            this.Controls.Remove((Control)tempNode.Tag);
                            this.panels.Remove((Control)tempNode.Tag);
                            tempNode.Tag = new ControlRegistry();
                            break;
                        case "RouletteWheel":
                            tempNode.Tag = new ControlRoulleteWheel();
                            (treeViewECF.Nodes[0].Nodes[0].Tag as panelAlgorithm).SetAlgorithm("RouletteWheel");
                            //sa setalgorithm ce se stvoriti novi cvor, tako da sad treba obrisati 
                            //taj novostvoreni prazni a na njegovo mjesto e doi tempNode
                            node.Nodes.Clear();
                            break;
                        case "SteadyStateTournament":
                            tempNode.Tag = new ControlSteadyState();
                            (treeViewECF.Nodes[0].Nodes[0].Tag as panelAlgorithm).SetAlgorithm("SteadyStateTournament");
                            node.Nodes.Clear();
                            break;

                    }
                    if (tempNode.Tag == null) continue;
                    ((xmlInterface)tempNode.Tag).FromXml(elem);
                    this.Controls.Add((Control)tempNode.Tag);
                    (tempNode.Tag as Control).Location = new Point(200, 20);
                    (tempNode.Tag as Control).Visible = false;
                    panels.Add((Control)tempNode.Tag);
                    node.Nodes.Add(tempNode);
                }

            }
                
        }
        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog()!=DialogResult.OK) return;
            if (!openFileDialog1.CheckFileExists) return;
            XmlDocument xmlDoc = new XmlDocument();
            try
            {
                xmlDoc.Load(openFileDialog1.FileName);
            }
            catch (Exception ex)
            {
                MessageBox.Show("Error while reading file");
                return;
            }
            //inace dolazi do flickering-a
            //zbog brisanja i dodavanja kontrola
            //pa prekidamo iscrtavanje forme dok ne napravimo sve sto trebamo
            SendMessage(this.Handle, 11, 0, 0);
            foreach (Control c in panels)
                this.Controls.Remove(c);
            panels.Clear();
           
            Init();
            
            traverseXMLDoc((XmlElement)xmlDoc.ChildNodes[0], treeViewECF.Nodes[0]);
            fileOpened = true;
            this.Text = openFileDialog1.FileName;
            //this.ResumeLayout();
            SendMessage(this.Handle, 11, 1, 0);
            //xmlDoc.
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (fileOpened)
            {
                XmlDocument xmlDoc = MakeXmlDocument();
                if (xmlDoc == null) return;
                FileStream fs = new FileStream(openFileDialog1.FileName, FileMode.Create);
                xmlDoc.Save(fs);
                fs.Close();
                
            }
            else
            {
                saveAsToolStripMenuItem_Click(sender, e);
            }
        }

        private void saveAsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            XmlDocument xmlDoc = MakeXmlDocument();
            if (xmlDoc == null) return;
            if (saveFileDialog1.ShowDialog() != DialogResult.OK) return;
            FileStream fs = new FileStream(saveFileDialog1.FileName, FileMode.Create);
            xmlDoc.Save(fs);
            fs.Close();
            openFileDialog1.FileName = saveFileDialog1.FileName;
            fileOpened = true;
        }

        private void newToolStripMenuItem_Click(object sender, EventArgs e)
        {
            foreach (Control c in panels)
                this.Controls.Remove(c);
            Init();
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void openLogToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (openFileDialogLog.ShowDialog() != DialogResult.OK) return;
           // if (!openFileDialogLog.CheckFileExists) return;
            FormLogViewer frmLogViewer = new FormLogViewer(openFileDialogLog.FileName);
            //forma se moze ugasiti zbog greske u otvaranju filea
            try
            {
                frmLogViewer.Show();
            }
            catch (Exception ex)
            {
                return;
            }
        }



            
   /*     private void comboBoxSelectAlg_SelectedIndexChanged(object sender, EventArgs e)
        {
            //TreeNodeCollection    

            TreeNode tempNode=new TreeNode(((ComboBox)sender).SelectedItem as string);

            if (tempNode.Name == "SteadyStateTournament")
                tempNode.Tag = controlSteadyState;
            else tempNode.Tag = controlRoulleteWheel;
            treeViewECF.Nodes[0].Nodes[0].Nodes.Clear();
            treeViewECF.Nodes[0].Nodes[0].Nodes.Add(tempNode);
        }*/
    }
}