using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace Seminar
{
    public delegate void AlgorithmChangedHandler(object source);
    public partial class panelAlgorithm : UserControl
    {
        public event AlgorithmChangedHandler AlgorithmChanged;
        public panelAlgorithm()
        {
            InitializeComponent();
              comboBoxSelectAlg.Items.Add("SteadyStateTournament");
              comboBoxSelectAlg.Items.Add("RouletteWheel");
        }

        private void comboBoxSelectAlg_SelectedIndexChanged(object sender, EventArgs e)
        {
            AlgorithmChanged(sender);
        }
        public void SetAlgorithm(string alg)
        {
            if (alg == "RouletteWheel") comboBoxSelectAlg.SelectedIndex = 1;
            else comboBoxSelectAlg.SelectedIndex = 0;
        }
    }
}
