using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace Seminar
{
    public delegate void GenotypesChangedHandler(object source,int changedIndex);
    public partial class controlGenotype : UserControl
    {
        public event GenotypesChangedHandler GenotypesChanged;
        List<string> usedGenotypes;
        public controlGenotype()
        {
            InitializeComponent();
            usedGenotypes=new List<string>();
            
          //  genotypes.AddRange("BitString","Binary","Tree");

            comboBoxGenotypes.Items.Add("BitString");
            comboBoxGenotypes.Items.Add("Binary");
            comboBoxGenotypes.Items.Add("Tree");
        }

        private void buttonAddGenotype_Click(object sender, EventArgs e)
        {
            listBox1.Items.Add(comboBoxGenotypes.SelectedItem);
            usedGenotypes.Clear();
            foreach(object o in listBox1.Items)
            {
                usedGenotypes.Add((string)o);
            }
          //  listBox1.Items.a = usedGenotypes;

           // usedGenotypes.Add(
            GenotypesChanged(sender,listBox1.Items.Count-1);
        }

        public List<string> Genotypes
        {
            get
            {
                return usedGenotypes;
            }
        }

        public void AddGenotype(string gen)
        {
            listBox1.Items.Add(gen);
        }

        private void buttonRemove_Click(object sender, EventArgs e)
        {
            int removeIndex = listBox1.SelectedIndex;
            if (removeIndex == -1) return;
            listBox1.Items.RemoveAt(removeIndex);
            usedGenotypes.Clear();
            foreach (object o in listBox1.Items)
            {
                usedGenotypes.Add((string)o);
            }
            //  listBox1.Items.a = usedGenotypes;

            // usedGenotypes.Add(
            GenotypesChanged(sender,removeIndex);
        }
                //items.a
                

    }
}

